cudnn_frontend::EngineConfigGenerator Class Reference

`#include <cudnn_frontend_EngineConfigGenerator.h>`

Collaboration diagram for cudnn_frontend::EngineConfigGenerator:

## Public Member Functions

| EngineConfigGenerator (int const sourceSize, GeneratorSource const *sources)
auto | generate_engine_config (cudnn_frontend::OperationGraph &opGraph) -> cudnn_frontend::EngineConfigList
auto | cudnnGetPlan (cudnnHandle_t handle, cudnn_frontend::OperationGraph &opGraph, Predicate pred) -> executionPlans_t
| Returns the concatenated plan in the order of heuristic results. More...
auto | cudnnGetPlan (cudnnHandle_t handle, cudnn_frontend::OperationGraph &opGraph) -> executionPlans_t
template<CudnnFindSamplingTechnique samplingTechnique>
auto | cudnnFindPlan (cudnnHandle_t handle, cudnn_frontend::OperationGraph &opGraph, cudnn_frontend::VariantPack const &variantPack, Predicate pred) -> executionPlans_t
template<CudnnFindSamplingTechnique samplingTechnique>
auto | cudnnFindPlan (cudnnHandle_t handle, cudnn_frontend::OperationGraph &opGraph, cudnn_frontend::VariantPack const &variantPack) -> executionPlans_t
template<CudnnFindSamplingTechnique samplingTechnique>
auto | cudnnFindPlanAndCache (cudnnHandle_t handle, cudnn_frontend::OperationGraph &opGraph, cudnn_frontend::VariantPack const &variantPack, cudnn_frontend::ExecutionPlanCache &cache, Predicate pred=[](const cudnn_frontend::ExecutionPlan &) {return false;}) -> cudnn_frontend::ExecutionPlan

## Private Attributes

std::vector< GeneratorSource > | engine_config_generators

## Detailed Description

EngineConfigGenerator class Contains a vector of methods that generate a vector of backend descriptor that can be used to create a plan for the method.

Definition at line 43 of file cudnn_frontend_EngineConfigGenerator.h.

## Constructor & Destructor Documentation

## EngineConfigGenerator()

cudnn_frontend::EngineConfigGenerator::EngineConfigGenerator | ( | int const | sourceSize,
|  | GeneratorSource const * | sources
| ) |  |

inline

Constructor that takes int a array of function pointers that will be called later. in the generate_engine_config function.

Definition at line 50 of file cudnn_frontend_EngineConfigGenerator.h.

## Member Function Documentation

## cudnnFindPlan() [1/2]

template<CudnnFindSamplingTechnique samplingTechnique>

auto cudnn_frontend::EngineConfigGenerator::cudnnFindPlan | ( | cudnnHandle_t | handle,
|  | cudnn_frontend::OperationGraph & | opGraph,
|  | cudnn_frontend::VariantPack const & | variantPack,
|  | Predicate | pred
| ) |  | -> executionPlans_t

Reruns the concatenated plans and measures the execution time following which a sorted order of executionPlans are return to the user.

Creating a set of execution plans that are supported.

Definition at line 117 of file cudnn_frontend_find_plan.h.

## cudnnFindPlan() [2/2]

template<CudnnFindSamplingTechnique samplingTechnique>

auto cudnn_frontend::EngineConfigGenerator::cudnnFindPlan | ( | cudnnHandle_t | handle,
|  | cudnn_frontend::OperationGraph & | opGraph,
|  | cudnn_frontend::VariantPack const & | variantPack
| ) |  | -> executionPlans_t

Creating a set of execution plans that are supported.

Definition at line 107 of file cudnn_frontend_find_plan.h.

## cudnnFindPlanAndCache()

template<CudnnFindSamplingTechnique samplingTechnique>

auto cudnn_frontend::EngineConfigGenerator::cudnnFindPlanAndCache | ( | cudnnHandle_t | handle,
|  | cudnn_frontend::OperationGraph & | opGraph,
|  | cudnn_frontend::VariantPack const & | variantPack,
|  | cudnn_frontend::ExecutionPlanCache & | cache,
|  | Predicate | pred = `[](const cudnn_frontend::ExecutionPlan &) {return false;}`
| ) |  | -> cudnn_frontend::ExecutionPlan

Creating a set of execution plans that are supported.

Check if the fastest plan is stable enough to be added to the plan cache

Definition at line 128 of file cudnn_frontend_find_plan.h.

## cudnnGetPlan() [1/2]

auto cudnn_frontend::EngineConfigGenerator::cudnnGetPlan | ( | cudnnHandle_t | handle,
|  | cudnn_frontend::OperationGraph & | opGraph,
|  | Predicate | pred
| ) |  | -> executionPlans_t

Returns the concatenated plan in the order of heuristic results.

Definition at line 50 of file cudnn_frontend_get_plan.h.

References cudnn_frontend::filter().

## cudnnGetPlan() [2/2]

auto cudnn_frontend::EngineConfigGenerator::cudnnGetPlan | ( | cudnnHandle_t | handle,
|  | cudnn_frontend::OperationGraph & | opGraph
| ) |  | -> executionPlans_t

Definition at line 30 of file cudnn_frontend_get_plan.h.

References cudnn_frontend::getLogger(), and cudnn_frontend::to_string().

## generate_engine_config()

auto cudnn_frontend::EngineConfigGenerator::generate_engine_config | ( | cudnn_frontend::OperationGraph & | opGraph | ) | -> cudnn_frontend::EngineConfigList

inline

Calls the vector of engine_config_generators one by one and concatenates the generated engine together into a single list.

Definition at line 59 of file cudnn_frontend_EngineConfigGenerator.h.

References cudnn_frontend::getLogger().

## Member Data Documentation

## engine_config_generators

std::vector<GeneratorSource> cudnn_frontend::EngineConfigGenerator::engine_config_generators

private

Definition at line 45 of file cudnn_frontend_EngineConfigGenerator.h.

The documentation for this class was generated from the following files:

- cudnn_frontend_EngineConfigGenerator.h
- cudnn_frontend_find_plan.h
- cudnn_frontend_get_plan.h